import pygame
import random
from Champs import *
import numpy as np
from Camera import Camera
from Image import *
from Temps import Temps
from Infrastructure import *
#Limite du zoom
RAYON_MUR_INVISIBLE = 2000
SAISONS = ["Printemps", "Été", "Automne", "Hiver"]
#Défini la police 
police = pygame.font.SysFont("roboto", 30)

    """
    @nom = Game :  Class : Classe principale du jeu
    @param : pas de parametre
    @return : void
    @Description :
    Constitue l'élément principal dans lequelle évolue le jeu
    """
class Game:
    imagestaticplantation = pygame.image.load('../assets/Interface/imagePlantation.jpeg')
    imagestaticbatiment = pygame.image.load('../assets/Interface/imageBatiment.jpeg')
    imagestaticinfor = pygame.image.load('../assets/Interface/imageinfo.jpg')

    """
    @nom = __init___ :  Méthode Constructor : Constructeur de la classe Game
    @param : pas de parametre
    @return : void
    @Description :
    Met en place l'interface et les éléments principaux du jeu
    """
    def __init__ (self):
        self.screen = pygame.display.set_mode((0,0), pygame.FULLSCREEN)
        self.image = Image(self.screen)
        self.screenSize = np.array(self.screen.get_size())
        self.score = 0
        self.money = 40000
        self.displayMoney = 40000
        self.month = 0
        self.nombreBatiments = 0
        self.nombreChamps = 0
        self.champs = []
        self.batiment = []

        self.temps = Temps()
        #Ajout des 12 champs de la partie
        for i in range(12):
            self.champs.append(Buisson(((i%4)*300-550,(i//4)*250-430)))
        
        #Pour les fps
        self.clock = pygame.time.Clock()
        self.selectedChamp = None

        #Attribut pour image money
        self.imageMoney = pygame.transform.scale(self.image.moneyImage, np.array(self.image.moneyImage.get_size())/5)

        self.camera = Camera(np.array(self.screen.get_size())/2)

        self.frame = 0
        self.buyFrame = -1000
        
        #Interface pour le tour suivant
        #Les 2 attributs pour la fleche qui change de proportion
        self.tourSuivantOriginal = self.image.arrowNextImage
        self.tourSuivantModif = pygame.transform.scale(self.tourSuivantOriginal, (100,100))

        #Défini l'interface le menu des batiments
        self.coordonne_info = pygame.rect.Rect(self.screen.get_width()*0.82,self.screen.get_height()*0.18,self.screen.get_width()*0.19,self.screen.get_height()*0.5)
        self.recInformation = pygame.rect.Rect(self.coordonne_info)
        self.rectPlantation = pygame.rect.Rect(0,0,self.temps.getImageSaison().get_width(),self.screen.get_height() -  self.temps.getImageSaison().get_height())
        self.recBatiment = pygame.rect.Rect(self.temps.getImageSaison().get_width(), self.screen.get_height() - self.temps.getImageSaison().get_height(), self.screen.get_width() * 0.65, self.temps.getImageSaison().get_height())


        #Background et hitbox pour le tour suivant et sa fleche
        self.coordonneeSuite = self.screenSize[0]-self.tourSuivantModif.get_width() - 120, self.screenSize[1] - self.tourSuivantModif.get_height() - 120
        self.suiteRectangle = pygame.rect.Rect(*self.coordonneeSuite, 100, 100)
        self.recTourSuivant = pygame.rect.Rect(
        self.recBatiment.x + self.recBatiment.w ,self.screen.get_height() - self.temps.getImageSaison().get_height(),
        self.screen.get_width() -  self.temps.getImageSaison().get_width() - self.recBatiment.w,self.temps.getImageSaison().get_height())
        
        #défini interface pour le menu des plantes
        self.rectPlantationimage = pygame.transform.scale(Game.imagestaticplantation,(self.rectPlantation.w,self.rectPlantation.h))
        self.rectBatimentimage = pygame.transform.scale(Game.imagestaticbatiment,(self.recBatiment.w,self.recBatiment.h))
        self.rectinfoimage = pygame.transform.scale(Game.imagestaticinfor,(self.recInformation.w,self.recInformation.h))

        
        
        #DragAndDrop
        self.dragBatiment = None
        self.dragPlantation = None
        


    """
    @nom = gameLoop : Boucle principale du jeu 
    @param : pas de parametre
    @return : void
    @Description :
    Méthode qui constitut la boucle prinicpale du jeu et qui fait évoluer la partie
    """
    def gameLoop (self):
        while True:

            self.screen.blit(self.image.backgroundImage, (0,0))

            #CHAMPS

            # Affichage des champs
            for champ in self.champs:
                champ.draw(self.screen, self.camera)

            # Affichage des batiments
            for bat in self.batiment:
                bat.draw(self.screen, self.camera)
            #DEBUT mise en place  INTERFACE

            #Onglet Information

            self.screen.blit(Game.imagestaticinfor,(self.coordonne_info.x,self.coordonne_info.y))

            # Onglet gestion de la météo
            self.screen.blit(self.temps.getImageSaison(), (0, self.screen.get_height() - 300))
            self.screen.blit(self.temps.iconSaison,(10,self.screen.get_height() - self.temps.iconSaison.get_height()))
            self.screen.blit(self.temps.tempsaisonImage,(10,self.screen.get_height() - self.temps.iconSaison.get_height() - 50))

            self.screen.blit(self.temps.nexticonSaison,(self.temps.getImageSaison().get_width() - self.temps.nexticonSaison.get_width(),self.screen.get_height() - self.temps.getImageSaison().get_height() +20))
            self.screen.blit(self.temps.tempsaisonImageDeuxPosiiton,(self.temps.getImageSaison().get_width() - self.temps.nexticonSaison.get_width(),self.screen.get_height() - self.temps.getImageSaison().get_height()))


            #Onglet plantation
            
            self.screen.blit(self.rectPlantationimage,(0,0))

            #Onglet tour suivant
            pygame.draw.rect(self.screen,(0, 127, 0),(self.recTourSuivant))
            self.screen.blit(self.tourSuivantModif, (self.recTourSuivant.x+ (self.recTourSuivant.w - self.tourSuivantModif.get_width())/2,
            self.recTourSuivant.y+ (self.recTourSuivant.h - self.tourSuivantModif.get_height())/2))

            #Boucle qui place tous les objets plantation dans le menu
            for i,c in enumerate(typePlantation):
                x = self.rectPlantation.x + ( 0 if i%2 else 170)
                y = self.rectPlantation.y + (i//2) * self.rectPlantationimage.get_height()/4

                # Redimensionner l'image
                c.iconStatic = transformImage(c.iconStatic, self.rectPlantationimage.get_width()/3.5, self.rectPlantationimage.get_height()/5.5)

                r = pygame.rect.Rect(x,y,c.iconStatic.get_width(),c.iconStatic.get_height()+ 20 )
                self.screen.blit(c.textStatic, (x,y))
                self.screen.blit(c.iconStatic,(x,y+c.textStatic.get_height() ))
                #Si la souris est dessus on affichage d'un rectangle
                if ( (r.collidepoint(pygame.mouse.get_pos()))):
                    pygame.draw.rect(self.screen,(138, 227, 237), r,1)
                    self.screen.blit(c.textDescriptionStatic,(self.recInformation.x,self.recInformation.y))
                
                
            #Onglet batiment 
            #Boucle qui place tous les objets infrastructure dans le menu
            self.screen.blit(self.rectBatimentimage,(self.temps.getImageSaison().get_width(),self.screen.get_height() - self.temps.getImageSaison().get_height()))
            for i,c in enumerate(typeBatiment):
                x = self.recBatiment.x + i* self.rectBatimentimage.get_width() / 6
                y = self.recBatiment.y + 50
                r = pygame.rect.Rect(x,y,c.iconStatic.get_width() + 20 ,c.iconStatic.get_height()+ 30 )
                self.screen.blit(c.textStatic, (x,y))
                self.screen.blit(c.iconStatic,(x,y + c.textStatic.get_height()))
                #Si la souris est dessus on affichage d'un rectangle
                if ( (r.collidepoint(pygame.mouse.get_pos()))):
                    pygame.draw.rect(self.screen,(138, 227, 237), r,1)
                    self.screen.blit(c.textDescriptionStatic,(self.recInformation.x,self.recInformation.y))
                       
            # FIN BOUCLE INTERFACE ------------------------


            isChamp = False

            #Compteur défilant de l'argent
            if self.money < self.displayMoney:
                self.displayMoney -= min(444, self.displayMoney - self.money) # Si quelque chose coûte moins que 100, changer par -= min(100, self.displayMoney - self.money)
            elif self.money > self.displayMoney:
                self.displayMoney+= min(444, self.money - self.displayMoney) # Si quelque chose coûte moins que 100, changer par -= min(100, self.money - self.displayMoney)
            
            #variable money
            textMoney = police.render(str(self.displayMoney), True, (255,255,255))

            #Variable pour la notif de perte/obtention d'argent
            self.CoRecArgent = pygame.rect.Rect(self.screen.get_width(), 0, 100, 100)
            self.recArgent = pygame.draw.rect(self.screen,(255,0,0),(self.CoRecArgent))

            self.screen.blit(textMoney, (self.screen.get_width() - self.imageMoney.get_width() - textMoney.get_width(),self.imageMoney.get_height()/2))
            self.screen.blit(self.imageMoney, (self.screen.get_width() - self.imageMoney.get_width() , 0))

            #Boucle pour chaque action de l'utilisateur
            for event in pygame.event.get():
                if event.type == pygame.QUIT or event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                    exit()

                #Deplacement de la souris
                elif event.type == pygame.MOUSEMOTION:
                    
                    if event.buttons[2] == 1: #maintenir enfoncé clic droit
                        self.camera.setPosition(np.array(event.rel))
                    #drag and drop 
                    #Pour l'item qui se deplace
                    if event.buttons[0] == 1:#maintenir enfoncé clic gauche
                        if self.dragBatiment == None and self.dragPlantation == None:
                            #Boucle pour suivre la souris
                            for i,c in enumerate(typeBatiment):
                                x = self.recBatiment.x + i* self.rectBatimentimage.get_width() / 6
                                y = self.recBatiment.y + 50
                                r = pygame.rect.Rect(x,y,c.iconStatic.get_width() + 20 ,c.iconStatic.get_height()+ 30 )
                                if ( (r.collidepoint(event.pos))):
                                    self.dragBatiment = c
                        if(self.dragBatiment):
                            self.screen.blit(self.dragBatiment.iconStatic, (event.pos))   

                    
                        if self.dragPlantation == None and self.dragBatiment == None: #POur empecher de prendre 2 items en drag
                            #Boucle pour suivre la souris
                            for i,c in enumerate(typePlantation):

                                x = self.rectPlantation.x + ( 0 if i%2 else 170) 
                                y = self.rectPlantation.y + (i//2) * self.rectPlantationimage.get_height()/4
                                r = pygame.rect.Rect(x,y,c.iconStatic.get_width() + 20 ,c.iconStatic.get_height()+ 30 )
                                if ( (r.collidepoint(event.pos))):
                                    self.dragPlantation = c
                                    
                        if(self.dragPlantation):
                            self.screen.blit(self.dragPlantation.iconStatic, (event.pos))
                            
                                
                    else:
                        #Pour un item plantation pris
                        if self.dragPlantation:
                            for champ in self.champs:
                                if champ.rectScale.collidepoint(event.pos):
                                    if self.dragPlantation == Pesticide:
                                        champ.isInfeste = False

                                    #Si l'emplacement est un champs libre
                                    elif isinstance(champ,TerrainVide):     
                                        #creation du nouvel objet dropé
                                        newChamp = self.dragPlantation(champ.pos)                                                                                                         
                                        self.champs.append(newChamp)
                                        newChamp.setInformation("Occupe" ,"Champ occupé")
                                        newChamp.setInformation("Nom", "Champ contient "+ self.dragPlantation.__name__)
                                        newChamp.setInformation("coutEntretien","90€ coût d'entretien mensuel")

                                        self.champs.remove(champ)
                                        #Perdre l'argent
                                        variable = self.dragPlantation.montantAchat
                                        self.moneyDefile(-variable)
                                   
                                        
                        #Pour un item plantation pris
                        if self.dragBatiment:
                            for champ in self.champs:
                                if champ.rectScale.collidepoint(event.pos):
                                    if isinstance(champ,TerrainVide) or type(champ) in typePlantation: 
                                        #Creation du nouvel objet
                                        newBat = self.dragBatiment(champ.pos) 
                                        self.batiment.append(newBat)
                                        champ.isbat = newBat
                                        
                                        #Ajout des informations dans le rectangle information
                                        newBat.setInformation("Occupe", "Espace occupé") 
                                        newBat.setInformation("Nom","Emplacement pour"+str(self.dragBatiment.NameObjet))
                                        newBat.setInformation("coutEntretien","117€ d'entretien mensuel ")
                                        champ.showInfo(self.screen,self.recInformation,newBat.descripteurInfrastructure)

                                        #Perdre l'argent
                                        variable = self.dragBatiment.montantAchat

                                        self.moneyDefile(-variable)
                                        self.nombreBatiments += 1
                                        #Exception où le non supprime pas le champs derrière
                                        if self.dragBatiment not in [Torche,Serre,Irrigation,IrrigationGoutte]:
                                            self.champs.remove(champ)
                                            
                                            self.nombreChamps -= 1
                                            
                        #Réinitialisation des pointeurs 
                        self.dragPlantation = None
                        self.dragBatiment = None
                    

                
                    #Boucle pour définir l'endroit comme un champ
                    for champ in self.champs + self.batiment:
                        if champ.rectScale.contains(event.pos[0],event.pos[1],0,0):
                            self.selectedChamp = champ
                            isChamp = True
                    

                    if not isChamp:
                        self.selectedChamp = None

                    #Remettre l'image fleche tour suivant par défaut quand on enlève la souris de la hitbox
                    if (*event.pos,0,0) in self.recTourSuivant:
                        self.tourSuivantModif = pygame.transform.scale(self.tourSuivantOriginal, (200, 200))
                    else:
                        self.tourSuivantModif = pygame.transform.scale(self.tourSuivantOriginal, (100, 100))
                    
                
                #Pour zoomer 
                elif event.type == pygame.MOUSEWHEEL:
                    self.camera.zoomInOut(event.y)

                
                elif event.type == pygame.MOUSEBUTTONDOWN:
                    
                    if event.button == 1: # Click gauche
                        #Declanchement du tour suivant
                        if(self.recTourSuivant.collidepoint(event.pos)):
                            self.coutEntretien()
                            self.temps.NextTurn()


                            #Code qui implemente la variation du pourcentage des plantes
                            self.ChangePourcentFanne(Serre,["orage"],2)
                            #Action si la saison est été
                            if (self.temps.currentSeason == "été"):
                                for bat in self.batiment:
                                    if (type(bat) == ReservoirEau):
                                        self.ChangePourcentFanne(ReservoirEau,["canicule","secheresse"],5,"chaud",2)
                                    elif(type(bat) == Puit):
                                        self.ChangePourcentFanne(Puit,["canicule","secheresse"],10,"chaud",5)
                                    elif(type(bat) == Irrigation):
                                        self.ChangePourcentFanne(Irrigation,["canicule","secheresse"],10,"chaud",5)
                                    elif(type(bat) == IrrigationGoutte):
                                        self.ChangePourcentFanne(IrrigationGoutte,["canicule","secheresse"],5,"chaud",2)
                                #Si il y a aucun batiment
                                if(len(self.batiment) == 0):
                                    for champ in self.champs:
                                        champ.pourcentagePlanteFane += 20
                                        champ.setInformation(hash('fane'),champ.pourcentagePlanteFane)
                            #Action si la saison est automne
                            elif (self.temps.currentSeason == "Automne"):
                                for bat in self.batiment:
                                    if (type(bat) == Serre):                              
                                        self.ChangePourcentFanne(Serre,["neige","froid"],5)
                                    elif(type(bat) == Puit):
                                        self.ChangePourcentFanne(Torche,["neige","froid"],10)
                                #Si il y a aucun batiment
                                if(len(self.batiment) == 0):
                                    for champ in self.champs:
                                        champ.pourcentagePlanteFane += 15
                                        champ.setInformation(hash('fane'),champ.pourcentagePlanteFane)
                            #Action si la saison est hiver
                            elif (self.temps.currentSeason == "Hiver"):
                                self.AideEtat()
                                for bat in self.batiment:
                                    if (type(bat) == Serre):                              
                                        self.ChangePourcentFanne(Serre,["neige","froid"],5)
                                    elif(type(bat) == Puit):
                                        self.ChangePourcentFanne(Torche,["neige","froid"],10)
                                if(len(self.batiment) == 0):
                                    for champ in self.champs:
                                        champ.pourcentagePlanteFane += 15
                                        champ.setInformation(hash('fane'),champ.pourcentagePlanteFane)
                            #Action si la saison est printemps
                            elif(self.temps.currentSeason == "Printemps"):
                                for bat in self.batiment:
                                    if (type(bat) == ReservoirEau):
                                        self.ChangePourcentFanne(ReservoirEau,["chaud"],2)
                                    elif(type(bat) == Puit):
                                        self.ChangePourcentFanne(Puit,["chaud"],5,)
                                    elif(type(bat) == Irrigation):
                                        self.ChangePourcentFanne(Irrigation,["chaud"],5)
                                    elif(type(bat) == IrrigationGoutte):
                                        self.ChangePourcentFanne(IrrigationGoutte,["chaud"],2)
                                #Si il y a aucun batiment
                                if(len(self.batiment) == 0):
                                    for champ in self.champs:
                                        champ.pourcentagePlanteFane += 15
                                        champ.setInformation(hash('fane'),champ.pourcentagePlanteFane)
                            
                            #Boucle pour verifier si la plante est infecté par les verres
                            for champ in self.champs: 
                                if type(champ) in typePlantation: 
                                    if champ.isInfeste:
                                        champ.indiceImage = 4
                                    self.VerifPlantFane(champ)
                                    if(random.random()< 0.10):
                                        champ.isInfeste = True

                            #verification de la durée de vie des batiments
                            for bat in self.batiment:
                                if(bat.verifDureeVie()):
                                    self.champs.append(TerrainVide(bat.pos))
                                    self.batiment.remove(bat)

                        # Achat 
                        for champ in self.champs: 

                            #click sur un champ
                            if champ.rectScale.collidepoint(event.pos):
                                #Vente des plantes 
                                if(champ.indiceImage > 3):
                                    self.champs.append(TerrainVide(champ.pos))
                                    self.champs.remove(champ)
                                elif(champ.indiceImage == 3):
                                    self.moneyDefile(champ.montantVente)
                                    self.champs.append(TerrainVide(champ.pos))
                                    self.champs.remove(champ)
                                    
                                 
                                #Achat d'un terrain vide
                                if isinstance(champ, Buisson):
                                    #if self.money >= champ.prix:
                                    self.moneyDefile(-champ.prix)
                                    self.champs.append(champ.buyField())
                                    self.champs.remove(champ)
                                    self.nombreChamps += 1

                                        

            if self.frame < self.buyFrame + 20:
                self.screen.blit(self.moneyChange, (self.screen.get_width() - self.imageMoney.get_width() - textMoney.get_width(), (self.frame-self.buyFrame)*1.5))
            
            #Pour le champ selectionnée afficher les infos dans le rectangle information
            if self.selectedChamp:
                self.selectedChamp.showInfo(self.screen,self.recInformation)
            pygame.display.update()
            self.clock.tick(50)
            self.frame += 1
        
    """
    @nom = moneyDefile : Fonction : additionne/soustrait l'argent du joueur
    @param : montant : int : montant additionné/soustrait de l'argent du joueur
    @return : void
    @Description :
    Fonction : additionne/soustrait l'argent du joueur
    """
    def moneyDefile(self,montant):
        self.moneyChange = police.render(str(montant), True, (200,0,0) if montant < 0 else (0,250,0) )
        self.buyFrame = self.frame
        self.money+= montant
        
     """
    @nom = AideEtat : Fonction : Ajoute de l'argent
    @param : 
    @return : void
    @Description :
    Simule les aides de l'état aux agriculteurs
    """
    def AideEtat(self):
        self.moneyDefile(5000)

     """
    @nom = ChangePourcentFanne : Fonction : Ajoute de l'argent
    @param : 
    @return : void
    @Description :
    Simule les aides de l'état aux agriculteurs
    """
    def ChangePourcentFanne(self,infra,case1,augmentation1, case2 = "",augmentation2 = 0):
        if not (infra in [type(bat) for bat in self.batiment]):
            if(self.temps.currentTempsName in case1):
                for champ in self.champs:
                    champ.pourcentagePlanteFane += augmentation1
                    champ.setInformation(hash('fane'),champ.pourcentagePlanteFane)
            elif(self.temps.currentTempsName == case2):
                for champ in self.champs:
                    champ.pourcentagePlanteFane += augmentation2
                    champ.setInformation(hash('fane'),champ.pourcentagePlanteFane)

    """
    @nom = VerifPlantFane : Fonction : Verfie la plante si elle fane
    @param : champ : Champs
    @return : void
    @Description :
    Tir au sort un nombre entre 0 et 100, si le nombre tiré est inférieur au pourcentage de chance de fane de la plante, la plante fane
    """
    def VerifPlantFane(self,champ):
        nbrrandom = random.randint(0,100)
        if nbrrandom < champ.pourcentagePlanteFane:
            champ.indiceImage = 4
        champ.plantationGrandit()

    """
    @nom = VerifPlantFane : Fonction : Calcule le coût d'entretien mensuel 
    @param : champ : Champs
    @return : void
    @Description :
    Calcule le coût d'entretien mensuel de chaque champs et batiment
    """
    def coutEntretien(self):
        cout = 0
        # Entretien des batiments pendant 3 mois
        if self.nombreBatiments > 0:
            cout += (-117 * self.nombreBatiments) * 3

        # Entretien des champs pendant 3 mois
        if self.nombreChamps > 0:
            cout += (-90 * self.nombreChamps) * 3

        self.moneyDefile(cout)
